Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2823)
@@ -17,4 +17,6 @@
    PUBLIC
 
+   INTEGER ::   numnatp
+
    !!*  Time variables
    INTEGER  ::   nrdttrc           !: ???
@@ -25,9 +27,9 @@
 
    !!*  Biological parameters 
-   REAL(wp) ::   part              !: ???
    REAL(wp) ::   rno3              !: ???
    REAL(wp) ::   o2ut              !: ???
    REAL(wp) ::   po4r              !: ???
    REAL(wp) ::   rdenit            !: ???
+   REAL(wp) ::   rdenita           !: ???
    REAL(wp) ::   o2nit             !: ???
    REAL(wp) ::   wsbio, wsbio2     !: ???
@@ -55,4 +57,8 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   concdfe    !: ???
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   concnfe    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimnfe    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimdfe    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimsi     !: ???
+
 
    !!*  SMS for the organic matter
@@ -62,6 +68,6 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xdiss      !: ??
 #if defined key_diatrc
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   prodcal    !: Calcite production
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   grazing    !: Total zooplankton grazing
+    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   prodcal    !: Calcite production
+    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   grazing    !: Total zooplankton grazing
 #endif
 
@@ -74,4 +80,9 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   borat      !: ???
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hi         !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   excess     !: ???
+
+   !!* Temperature dependancy of SMS terms
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc    !: Temp. dependancy of various biological rates
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   tgfunc2   !: Temp. dependancy of mesozooplankton rates
 
    !!* Array used to indicate negative tracer values
@@ -98,32 +109,37 @@
       !!----------------------------------------------------------------------
       USE lib_mpp , ONLY: ctl_warn
-      INTEGER ::   ierr(5)        ! Local variables
+      INTEGER ::   ierr(6)        ! Local variables
       !!----------------------------------------------------------------------
       ierr(:) = 0
-      !
       !*  Biological fluxes for light
-      ALLOCATE( neln(jpi,jpj), heup(jpi,jpj),                           STAT=ierr(1) )
+      ALLOCATE( neln(jpi,jpj), heup(jpi,jpj),                   STAT=ierr(1) )
       !
       !*  Biological fluxes for primary production
-      ALLOCATE( xksimax(jpi,jpj)     , xksi(jpi,jpj)        ,               &
-         &      xnanono3(jpi,jpj,jpk), xdiatno3(jpi,jpj,jpk),               &
-         &      xnanonh4(jpi,jpj,jpk), xdiatnh4(jpi,jpj,jpk),               &
-         &      xlimphy (jpi,jpj,jpk), xlimdia (jpi,jpj,jpk),               &
-         &      concdfe (jpi,jpj,jpk), concnfe (jpi,jpj,jpk),           STAT=ierr(2) ) 
+      ALLOCATE( xksimax(jpi,jpj)     , xksi(jpi,jpj)        ,       &
+         &      xnanono3(jpi,jpj,jpk), xdiatno3(jpi,jpj,jpk),       &
+         &      xnanonh4(jpi,jpj,jpk), xdiatnh4(jpi,jpj,jpk),       &
+         &      xlimphy (jpi,jpj,jpk), xlimdia (jpi,jpj,jpk),       &
+         &      xlimnfe (jpi,jpj,jpk), xlimdfe (jpi,jpj,jpk),       &
+         &      xlimsi  (jpi,jpj,jpk), concdfe (jpi,jpj,jpk),       &
+         &      concnfe (jpi,jpj,jpk),                          STAT=ierr(2) ) 
          !
-      !*  SMS for the organic matter
+       !*  SMS for the organic matter
       ALLOCATE( xfracal (jpi,jpj,jpk), nitrfac (jpi,jpj,jpk),               &
 #if defined key_diatrc
          &      prodcal(jpi,jpj,jpk) , grazing(jpi,jpj,jpk) ,               &
 #endif 
-         &      xlimbac (jpi,jpj,jpk), xdiss(jpi,jpj,jpk)   ,           STAT=ierr(3) )  
+         &      xlimbac (jpi,jpj,jpk), xdiss(jpi,jpj,jpk)   ,   STAT=ierr(3) )  
+
+      !* Variable for chemistry of the CO2 cycle
+      ALLOCATE( akb3(jpi,jpj,jpk)    , ak13  (jpi,jpj,jpk) ,       &
+         &      ak23(jpi,jpj,jpk)    , aksp  (jpi,jpj,jpk) ,       &
+         &      akw3(jpi,jpj,jpk)    , borat (jpi,jpj,jpk) ,       &
+         &      hi  (jpi,jpj,jpk)    , excess(jpi,jpj,jpk) ,   STAT=ierr(4) )
          !
-      !* Variable for chemistry of the CO2 cycle
-      ALLOCATE( akb3(jpi,jpj,jpk), ak13(jpi,jpj,jpk) ,                      &
-         &      ak23(jpi,jpj,jpk), aksp(jpi,jpj,jpk) ,                      &
-         &      akw3(jpi,jpj,jpk), borat(jpi,jpj,jpk), hi(jpi,jpj,jpk), STAT=ierr(4) )
+      !* Temperature dependancy of SMS terms
+      ALLOCATE( tgfunc(jpi,jpj,jpk)  , tgfunc2(jpi,jpj,jpk) ,   STAT=ierr(5) )
          !
       !* Array used to indicate negative tracer values  
-      ALLOCATE( xnegtr(jpi,jpj,jpk),                                    STAT=ierr(5) )
+      ALLOCATE( xnegtr(jpi,jpj,jpk)  ,                          STAT=ierr(6) )
       !
       sms_pisces_alloc = MAXVAL( ierr )
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2823)
@@ -17,15 +17,13 @@
    !!----------------------------------------------------------------------
    USE par_trc         ! TOP parameters
-   USE sms_pisces      ! Source Minus Sink variables
-   USE trc
-   USE oce_trc         ! ocean variables
-   USE p4zche 
-   USE p4zche          ! 
-   USE p4zsink         ! 
-   USE p4zopt          ! 
-   USE p4zprod         !
-   USE p4zrem          ! 
-   USE p4zsed          ! 
-   USE p4zflx          ! 
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zche          !  Chemical model
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zopt          !  optical model
+   USE p4zrem          !  Remineralisation of organic matter
+   USE p4zflx          !  Gas exchange
+   USE p4zsed          !  Sedimentation
 
    IMPLICIT NONE
@@ -40,5 +38,5 @@
    REAL(wp) :: bioma0 =  1.000e-8_wp  
    REAL(wp) :: silic1 =  91.65e-6_wp  
-   REAL(wp) :: no3    =  31.04e-6_wp * 7.6_wp
+   REAL(wp) :: no3    =  31.04e-6_wp * 7.625_wp
 
 #  include "top_substitute.h90"
@@ -76,9 +74,10 @@
       ! Set biological ratios
       ! ---------------------
-      rno3   = (16.+2.) / 122.
-      po4r   =   1.e0   / 122.
-      o2nit  =  32.     / 122.
-      rdenit =  97.6    /  16.
-      o2ut   = 140.     / 122.
+      rno3    =  16._wp / 122._wp
+      po4r    =   1._wp / 122._wp
+      o2nit   =  32._wp / 122._wp
+      rdenit  = 105._wp /  16._wp
+      rdenita =   3._wp /  5._wp
+      o2ut    = 131._wp / 122._wp
 
       CALL p4z_che        ! initialize the chemical constants
@@ -136,11 +135,10 @@
       !! ** Purpose :   Allocate all the dynamic arrays of PISCES 
       !!----------------------------------------------------------------------
-      USE p4zint , ONLY : p4z_int_alloc      
-      USE p4zsink, ONLY : p4z_sink_alloc      
-      USE p4zopt , ONLY : p4z_opt_alloc           
-      USE p4zprod, ONLY : p4z_prod_alloc         
-      USE p4zrem , ONLY : p4z_rem_alloc           
-      USE p4zsed , ONLY : p4z_sed_alloc          
-      USE p4zflx , ONLY : p4z_flx_alloc
+      USE p4zsink , ONLY : p4z_sink_alloc      
+      USE p4zopt  , ONLY : p4z_opt_alloc           
+      USE p4zprod , ONLY : p4z_prod_alloc         
+      USE p4zrem  , ONLY : p4z_rem_alloc           
+      USE p4zsed  , ONLY : p4z_sed_alloc          
+      USE p4zflx  , ONLY : p4z_flx_alloc
       !
       INTEGER :: ierr
@@ -148,12 +146,11 @@
       !
       ierr =         sms_pisces_alloc()          ! Start of PISCES-related alloc routines...
-      ierr = ierr +     p4z_che_alloc()
-      ierr = ierr +     p4z_int_alloc()
-      ierr = ierr +    p4z_sink_alloc()
-      ierr = ierr +     p4z_opt_alloc()
-      ierr = ierr +    p4z_prod_alloc()
-      ierr = ierr +     p4z_rem_alloc()
-      ierr = ierr +     p4z_sed_alloc()
-      ierr = ierr +     p4z_flx_alloc()
+      ierr = ierr +  p4z_che_alloc()
+      ierr = ierr +  p4z_sink_alloc()
+      ierr = ierr +  p4z_opt_alloc()
+      ierr = ierr +  p4z_prod_alloc()
+      ierr = ierr +  p4z_rem_alloc()
+      ierr = ierr +  p4z_sed_alloc()
+      ierr = ierr +  p4z_flx_alloc()
       !
       IF( lk_mpp    )   CALL mpp_sum( ierr )
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2823)
@@ -19,4 +19,5 @@
    USE trc             ! TOP variables
    USE sms_pisces      ! sms trends
+   USE in_out_manager  ! I/O manager
 
 
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2823)
@@ -43,5 +43,5 @@
 
       !
-      IF( lk_dtatrc .AND. ln_pisclo ) CALL pis_dmp_clo  ! restoring of nutrients on close seas
+      IF( ln_trcdta .AND. ln_pisclo ) CALL pis_dmp_clo  ! restoring of nutrients on close seas
       IF( ln_pisdmp )                 CALL pis_dmp_ini  ! relaxation of some tracers
       !
@@ -120,15 +120,15 @@
 
          zarea   = 1. / areatot * 1.e6
-# if defined key_degrad
-         zalksum = glob_sum( trn(:,:,:,jptal) * cvol(:,:,:) * facvol(:,:,:) ) * zarea
-         zpo4sum = glob_sum( trn(:,:,:,jppo4) * cvol(:,:,:) * facvol(:,:,:) ) * zarea / 122.
-         zno3sum = glob_sum( trn(:,:,:,jpno3) * cvol(:,:,:) * facvol(:,:,:) ) * zarea / 7.6
-         zsilsum = glob_sum( trn(:,:,:,jpsil) * cvol(:,:,:) * facvol(:,:,:) ) * zarea
-# else
-         zalksum = glob_sum( trn(:,:,:,jptal) * cvol(:,:,:)  ) * zarea
-         zpo4sum = glob_sum( trn(:,:,:,jppo4) * cvol(:,:,:)  ) * zarea / 122.
-         zno3sum = glob_sum( trn(:,:,:,jpno3) * cvol(:,:,:)  ) * zarea / 7.6
-         zsilsum = glob_sum( trn(:,:,:,jpsil) * cvol(:,:,:)  ) * zarea
-# endif
+         IF( lk_degrad ) THEN
+            zalksum = glob_sum( trn(:,:,:,jptal) * cvol(:,:,:) * facvol(:,:,:) ) * zarea
+            zpo4sum = glob_sum( trn(:,:,:,jppo4) * cvol(:,:,:) * facvol(:,:,:) ) * zarea / 122.
+            zno3sum = glob_sum( trn(:,:,:,jpno3) * cvol(:,:,:) * facvol(:,:,:) ) * zarea / 7.6
+            zsilsum = glob_sum( trn(:,:,:,jpsil) * cvol(:,:,:) * facvol(:,:,:) ) * zarea
+         ELSE
+            zalksum = glob_sum( trn(:,:,:,jptal) * cvol(:,:,:)  ) * zarea
+            zpo4sum = glob_sum( trn(:,:,:,jppo4) * cvol(:,:,:)  ) * zarea / 122.
+            zno3sum = glob_sum( trn(:,:,:,jpno3) * cvol(:,:,:)  ) * zarea / 7.6
+            zsilsum = glob_sum( trn(:,:,:,jpsil) * cvol(:,:,:)  ) * zarea
+         ENDIF
 
          IF(lwp) WRITE(numout,*) '       TALK mean : ', zalksum
@@ -168,8 +168,10 @@
       !!                ictsi2(), ictsj2() : north-east Closed sea limits (i,j)
       !!----------------------------------------------------------------------
-      INTEGER, PARAMETER           ::   npicts   = 4       !: number of closed sea
-      INTEGER, DIMENSION(npicts)   ::   ictsi1, ictsj1     !: south-west closed sea limits (i,j)
-      INTEGER, DIMENSION(npicts)   ::   ictsi2, ictsj2     !: north-east closed sea limits (i,j)
-      INTEGER :: ji, jj, jk, jn, jc            ! dummy loop indices
+      INTEGER, PARAMETER           ::   npicts   = 4        ! number of closed sea
+      INTEGER, DIMENSION(npicts)   ::   ictsi1, ictsj1      ! south-west closed sea limits (i,j)
+      INTEGER, DIMENSION(npicts)   ::   ictsi2, ictsj2      ! north-east closed sea limits (i,j)
+      INTEGER :: ji, jj, jk, jn, jl, jc                     ! dummy loop indices
+      INTEGER :: ierr                                       ! local integer
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  ztrcdta ! 4D  workspace
       !!----------------------------------------------------------------------
 
@@ -243,23 +245,31 @@
       END DO
 
-#if defined key_dtatrc
       ! Restore close seas values to initial data
-      CALL trc_dta( nit000 ) 
-      DO jn = 1, jptra
-         IF( lutini(jn) ) THEN
-            DO jc = 1, npicts
-               DO jk = 1, jpkm1
-                  DO jj = ictsj1(jc), ictsj2(jc)
-                     DO ji = ictsi1(jc), ictsi2(jc)
-                        trn(ji,jj,jk,jn) = trdta(ji,jj,jk,jn) * tmask(ji,jj,jk) 
-                        trb(ji,jj,jk,jn) = trn(ji,jj,jk,jn)
-                     ENDDO
-                  ENDDO
-               ENDDO
-            ENDDO
-         ENDIF
-      ENDDO
-#endif
-   !
+      IF( nb_trcdta > 0 ) THEN  ! Initialisation of tracer from a file that may also be used for damping
+        ALLOCATE( ztrcdta(jpi,jpj,jpk,nb_trcdta), STAT=ierr )
+        IF( ierr > 0 ) THEN
+           CALL ctl_stop( 'trc_ini: unable to allocate ztrcdta array' )   ;   RETURN
+        ENDIF
+        !
+        CALL trc_dta( nit000, ztrcdta )   ! read tracer data at nit000
+        !
+        DO jn = 1, jptra
+           IF( ln_trc_ini(jn) ) THEN      ! update passive tracers arrays with input data read from file
+              jl = n_trc_index(jn)
+              DO jc = 1, npicts
+                 DO jk = 1, jpkm1
+                    DO jj = ictsj1(jc), ictsj2(jc)
+                       DO ji = ictsi1(jc), ictsi2(jc)
+                          trn(ji,jj,jk,jn) = ztrcdta(ji,jj,jk,jl) * tmask(ji,jj,jk) 
+                          trb(ji,jj,jk,jn) = trn(ji,jj,jk,jn)
+                       ENDDO
+                    ENDDO
+                 ENDDO
+              ENDDO
+           ENDIF
+        ENDDO
+        DEALLOCATE( ztrcdta )
+      ENDIF
+      !
    END SUBROUTINE pis_dmp_clo
 
Index: branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90
===================================================================
--- branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2822)
+++ branches/2011/dev_r2787_PISCES_improvment/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2823)
@@ -13,29 +13,25 @@
    !!   trcsms_pisces        :  Time loop of passive tracers sms
    !!----------------------------------------------------------------------
-   USE oce_trc         !
-   USE trc
-   USE sms_pisces
-   
-   USE p4zint          ! 
-   USE p4zche          ! 
-   USE p4zbio          ! 
-   USE p4zsink         ! 
-   USE p4zopt          ! 
-   USE p4zlim          ! 
-   USE p4zprod         !
-   USE p4zmort         !
-   USE p4zmicro        ! 
-   USE p4zmeso         ! 
-   USE p4zrem          ! 
-   USE p4zsed          ! 
-   USE p4zlys          ! 
-   USE p4zflx          ! 
-
-   USE prtctl_trc
-
-   USE trdmod_oce
-   USE trdmod_trc
-
-   USE sedmodel
+   USE oce_trc         !  shared variables between ocean and passive tracers
+   USE trc             !  passive tracers common variables 
+   USE sms_pisces      !  PISCES Source Minus Sink variables
+   USE p4zbio          !  Biological model
+   USE p4zche          !  Chemical model
+   USE p4zsink         !  vertical flux of particulate matter due to sinking
+   USE p4zopt          !  optical model
+   USE p4zlim          !  Co-limitations of differents nutrients
+   USE p4zprod         !  Growth rate of the 2 phyto groups
+   USE p4zmort         !  Mortality terms for phytoplankton
+   USE p4zmicro        !  Sources and sinks of microzooplankton
+   USE p4zmeso         !  Sources and sinks of mesozooplankton
+   USE p4zrem          !  Remineralisation of organic matter
+   USE p4zlys          !  Calcite saturation
+   USE p4zflx          !  Gas exchange
+   USE p4zsed          !  Sedimentation
+   USE p4zint          !  time interpolation
+   USE trdmod_oce      !  Ocean trends variables
+   USE trdmod_trc      !  TOP trends variables
+   USE sedmodel        !  Sediment model
+   USE prtctl_trc      !  print control for debugging
 
    IMPLICIT NONE
@@ -86,6 +82,6 @@
          IF(lwp) write(numout,*) '~~~~~~'
 
-         CALL p4z_che          ! computation of chemical constants
-         CALL p4z_int          ! computation of various rates for biogeochemistry
+         CALL p4z_che              ! computation of chemical constants
+         CALL p4z_int              ! computation of various rates for biogeochemistry
          !
       ENDIF
@@ -128,5 +124,5 @@
       ENDIF
 
-      IF( wrk_not_released(3,1) ) CALL ctl_stop('trc_sms_pisces : failed to release workspace array.') 
+      IF( wrk_not_released(3, 1) ) CALL ctl_stop('trc_sms_pisces : failed to release workspace array.') 
 
    END SUBROUTINE trc_sms_pisces
@@ -164,15 +160,15 @@
       xstep = rfact2 / rday
 
-      CALL p4z_sink_init      ! vertical flux of particulate organic matter
-      CALL p4z_opt_init       ! Optic: PAR in the water column
-      CALL p4z_lim_init       ! co-limitations by the various nutrients
-      CALL p4z_prod_init      ! phytoplankton growth rate over the global ocean. 
-      CALL p4z_rem_init       ! remineralisation
-      CALL p4z_mort_init      ! phytoplankton mortality
-      CALL p4z_micro_init     ! microzooplankton
-      CALL p4z_meso_init      ! mesozooplankton
-      CALL p4z_sed_init       ! sedimentation
-      CALL p4z_lys_init       ! calcite saturation
-      CALL p4z_flx_init       ! gas exchange
+      CALL p4z_sink_init      !  vertical flux of particulate organic matter
+      CALL p4z_opt_init       !  Optic: PAR in the water column
+      CALL p4z_lim_init       !  co-limitations by the various nutrients
+      CALL p4z_prod_init      !  phytoplankton growth rate over the global ocean. 
+      CALL p4z_rem_init       !  remineralisation
+      CALL p4z_mort_init      !  phytoplankton mortality
+      CALL p4z_micro_init     !  microzooplankton
+      CALL p4z_meso_init      !  mesozooplankton
+      CALL p4z_sed_init       !  sedimentation
+      CALL p4z_lys_init       !  calcite saturation
+      CALL p4z_flx_init       !  gas exchange
 
       ndayflxtr = 0
